# !/bin/bash
# Custom script to create SD Card image 
# WARNING: Experimental, not working with other targets

# [Internal] Source utilities scripts 
if [ -r "$PLATFORM_LOC/scripts/utils.sh" ]; then
	source "$PLATFORM_LOC/scripts/utils.sh"
else
	source "$script_lib_dir/utils.sh"
fi

BUILDSTEP_SCRIPT_DIR=$(dirname $BUILDSTEP_SCRIPT_PATH)
source ${BUILDSTEP_SCRIPT_DIR}/sdcardBuilder.sh

do_buildstep_prepend

# Scale factor to get valid rootfs image size
# Note: The image size has to be bigger than the folder size, it ensure no error,
# 		The user can manually reduce image size afterward
: ${ROOTFS_SCALE_FACTOR:=1.3}

# Search tsv file 

if [ -z ${TSVFILE} ] ; then
	fatal "Missing tsv file; Please set the variable TSVFILE to the SD Card layout TSV file"
else
	LAYOUT=${TSVFILE}
fi


# Create temporary workdir
mkdir -p temp
rm -rf temp/*
imagesDir=temp

# Get boot folder and format it with the right format and provide ${BOOTFS}
imgRoot="${PROJECT_LOC}/output/boot"
cp ${imgRoot} ${imagesDir} -r #
bootPartOutput="bootPart"
tempBoot="${imagesDir}/boot" #
#mv extlinux ${tempBoot} #

mkdir -p ${tempBoot}/extlinux

# Get size of the boot part # ${PROJECT_LOC}/output/boot
defaultSize=$(du -ks ${tempBoot}  | sed 's/\t.*//')    #We know that the integer count will be follow by a \t and then some scrap
defaultSize=$(expr ${defaultSize}*${ROOTFS_SCALE_FACTOR} | bc)
imgSize=${defaultSize%%.*}


log_exec generate_rootfs ${tempBoot} vfat ${bootPartOutput} BOOT ${imgSize}

BOOTFS=${imagesDir}/${bootPartOutput}.vfat
log "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ${BOOTFS} !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"

# Sometimes empty partitions are required ...
DONOTPOPULATE=${imagesDir}/nop.ext4
touch ${DONOTPOPULATE}

# Check rootfs existence
if [ ! -f ${ROOTFS} ] ; then
	fatal "Cannot retrieve the rootfs image: ${ROOTFS}; Please set the variable ROOTFS to the rootfs ext image"
fi  

# Call sdcard builder and generate the sdcard file

log "==== Info ===="
log " bootfs ${BOOTFS}"
log " rootfs ${ROOTFS}"

log_exec do_create_sdcard_file ${LAYOUT} 


# Remove the temp directory
rm -rf temp

do_buildstep_append
